import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Clase Calabozo, esta clase es el mundo, o ambiente del juego, realiza el manejo de menus, asi como el cambio de vidas del jugador,
 * cambios de nivel y creaccion aleatoria de cada nivel.
 */
public class Calabozo extends World
{
    private int nivel=0;
    private int vidas=3;
    private int x;
    private int y;
    private int p=0;
    private int limiteIzq=25;
    private int limiteDer=575;
    private int limiteSup=25;
    private int limiteInf=415;
    private CVida muestra;
    private Jugador jugador;
    private int numCuartos=0;
    private int numPh=0;
    private int numPv=0;
    private int vidaDragon=5;
    GreenfootSound track1= new GreenfootSound("darkworld.mp3");
    GreenfootSound track2= new GreenfootSound("dungeon.mp3");
    private Letrero letrero=null;
    private Dragon dragon = new Dragon();
    /**
     * Constructor for objects of class Calabozo.
     */
    public Calabozo()
    {
        super(600,500,1);
        track1.setVolume(100);
        track2.setVolume(100);

        menu();
    }
    
    /**
     * actua del menuque realiza la colocacion del menu y juego.
     */
    public void act()
    {
        if(nivel==0)
           start1();
        if(nivel!=0)
           cambia();
        if(nivel==0 && Greenfoot.isKeyDown("enter"))
            menu();
    }
    
    /**
     * Metodo que crea el menu y añade los botones de este.
     */
    public void menu()
    {

        muestra = new CVida();
        setBackground("menu.png");
        super.addObject(new Juego(), 195, 212);
        super.addObject(new Ayuda(), 81, 328);
        super.addObject(new Creditos(), 81, 113);

    }
    
    /**
     * Metodo de la accion que se realiza al preionar el boton de jugar.
     */
    public void juego()
    {
        setLevel(nivel);
    }
    
    /**
     * Metodo que realiza la accion al presionar el boton de Ayuda
     */
    public void Ayuda()
    {
        removeObjects(getObjects(Ayuda.class));
        removeObjects(getObjects(Juego.class));
        removeObjects(getObjects(Creditos.class));
        setBackground("tayuda.png");
    }
    
    /**
     * Metodo que realiza la accion al presionar el boton de Creditos
     */
    public void Creditos()
    {
        removeObjects(getObjects(Ayuda.class));
        removeObjects(getObjects(Juego.class));
        removeObjects(getObjects(Creditos.class));
        setBackground("tcreditos.png");
    }
    
    /**
     * Metodo que realiza la pantalla de victoria cuando se mata al dragon.
     */
    public void ganaste()
    {
        removeObjects(getObjects(Canon.class));
        removeObjects(getObjects(Dragon.class));
        removeObjects(getObjects(Jugador.class));
        removeObjects(getObjects(Pocion.class));
        removeObjects(getObjects(Llave.class));
        removeObjects(getObjects(Letrero.class));
        removeObjects(getObjects(CVida.class));        
        setBackground("ganaste.png");
        nivel=0;
    }
    
    /**
     * Metodo para desaparecer la bala.
     */
    public void desaparece()
    {
        removeObjects(getObjects(Bala.class));
        removeObjects(getObjects(Bala.class));
    }
    
    /**
     * Metodo para generar el nivel cuando inicia el juego.
     */
    public void setLevel(int nivel)
    {
        if(nivel==0)
        {
            nivel=1;
            nivel1();
        }
        else
        {
            generaNivel();
            letrero.cambiaLetrero(nivel);
        }
    }
    
    /**
     * Metodo para verificar que nivel se realizara y verifica si no se ha llegado al nivel final se crea este.
     */
    public void nextLevel()
    {
        nivel=5;
        letrero.cambiaLetrero(nivel);
        if(nivel==5)
            nivelFinal();
        else
            setLevel(nivel);
    }
    
    /**
     * Metodo para reducir las vidas del jugador asi mismo si el jugador pierde crea la pantalla de game over.
     */
    public void reduceVida()
    {
        vidas--;
        muestra.cambia(vidas);
        if(vidas==0)
        {
            removeObjects(getObjects(Escalera.class));
            removeObjects(getObjects(Ene1.class));
            removeObjects(getObjects(Ene2.class));
            removeObjects(getObjects(Llave.class));
            removeObjects(getObjects(Jugador.class));
            removeObjects(getObjects(CVida.class));
            removeObjects(getObjects(Letrero.class));
            removeObjects(getObjects(Dragon.class));
            removeObjects(getObjects(Fuego.class));
            setBackground("perdiste.png");
            track2.stop();
            track1.play();
        }
    }
    
    /**
     * Metodo que reduce una vida del dragon y verifica si has ganado.
     */
    public void quitaVida()
    {
        vidaDragon--;
        if(vidaDragon==0)
        {
            ganaste();
        }
    }
    
    /**
     * Metodo que aumenta la vida en uno del jugador.
     */
    public void aumentaVida()
    {
        if(vidas!=3)
        {
           vidas++;
           muestra.cambia(vidas);
        }
    }
    
    /**
     * Metodo que crea en el mundo una bala cuando se golpea un canon
     */
    public void dispara(int numero)
    {
        switch(numero)
        {
            case 1:
            Bala bala=new Bala();
            addObject(bala,360,154);
            break;
            case 2:
            Bala bala2=new Bala();
            addObject(bala2,360,250);
            break;
            case 3:
            Bala bala3=new Bala();
            addObject(bala3,360,340);
            break;
        }
    }
    
    /**
     * Metodo que genera de manera aleatoria el numero de enemigos y su ubicacion.
     */
    public void generaNivel()
    {
        int nEne1=Greenfoot.getRandomNumber(5)+1;
        int nEne2=Greenfoot.getRandomNumber(5)+1;
        removeObjects(getObjects(Escalera.class));
        removeObjects(getObjects(Ene1.class));
        removeObjects(getObjects(Ene2.class));
        removeObjects(getObjects(Llave.class));
        removeObjects(getObjects(Pocion.class));
        int randomX=0;
        int randomY=0;
        randomX=Greenfoot.getRandomNumber(548)+25;
        randomY=Greenfoot.getRandomNumber(393)+25;
        Escalera es =new Escalera();
        addObject(es,50,20);
        
        if(nEne1==1)
        {
            Ene1 ene1 = new Ene1();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(ene1, 204, 210);
        }
        else if(nEne1==2)
        {
            Ene1 ene12=new Ene1();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(ene12,randomX,randomY);
            Ene1 ene13=new Ene1();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(ene13,randomX,randomY);
        }
        else if(nEne1==3)
        {
            Ene1 ene14=new Ene1();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(ene14,randomX,randomY);
            Ene1 ene15=new Ene1();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(ene15,randomX,randomY);
            Ene1 ene16=new Ene1();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(ene16,randomX,randomY);
        }
        else if(nEne1==4)
        {
            Ene1 ene17=new Ene1();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(ene17,randomX,randomY);
            Ene1 ene18=new Ene1();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(ene18,randomX,randomY);
            Ene1 ene19=new Ene1();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(ene19,randomX,randomY);
            Ene1 ene110=new Ene1();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(ene110,randomX,randomY);
        }
        else if(nEne1==5)
        {
            Ene1 ene111=new Ene1();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(ene111,randomX,randomY);
            Ene1 ene112=new Ene1();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(ene112,randomX,randomY);
            Ene1 ene113=new Ene1();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(ene113,randomX,randomY);
            Ene1 ene114=new Ene1();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(ene114,randomX,randomY);
            Ene1 ene115=new Ene1();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(ene115,randomX,randomY);
        }

        if(nEne2==1)
        {
            Ene2 Enem2=new Ene2();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(Enem2,randomX,randomY);
        }
        else if(nEne2==2)
        {
            Ene2 Enem21=new Ene2();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(Enem21,randomX,randomY);
            Ene2 Enem22=new Ene2();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(Enem22,randomX,randomY);
        }
        else if(nEne2==3)
        {
            Ene2 Enem24=new Ene2();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(Enem24,randomX,randomY);
            Ene2 Enem25=new Ene2();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(Enem25,randomX,randomY);
            Ene2 Enem26=new Ene2();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(Enem26,randomX,randomY);
        }
        else if(nEne2==4)
        {
            Ene2 Enem27=new Ene2();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(Enem27,randomX,randomY);
            Ene2 Enem28=new Ene2();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(Enem28,randomX,randomY);
            Ene2 Enem29=new Ene2();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(Enem29,randomX,randomY);
            Ene2 Enem210=new Ene2();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(Enem210,randomX,randomY);
        }
        else if(nEne2==5)
        {
            Ene2 Enem211=new Ene2();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(Enem211,randomX,randomY);
            Ene2 Enem212=new Ene2();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(Enem212,randomX,randomY);
            Ene2 Enem213=new Ene2();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(Enem213,randomX,randomY);
            Ene2 Enem214=new Ene2();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(Enem214,randomX,randomY);
            Ene2 Enem215=new Ene2();
            randomX=Greenfoot.getRandomNumber(548)+25;
            randomY=Greenfoot.getRandomNumber(393)+25;
            addObject(Enem215,randomX,randomY);
        }
        
        Pocion pocion = new Pocion();
        randomX=Greenfoot.getRandomNumber(548)+25;
        randomY=Greenfoot.getRandomNumber(393)+25;
        addObject(pocion, randomX, randomY);
        //cambiaPared();
    }

    /* public void cambiaPared()
    {
    int rcuartos=Greenfoot.getRandomNumber(4)+1;
    if(rcuartos<=2)
    {
    numPh=Greenfoot.getRandomNumber(2)+1;
    numPv=Greenfoot.getRandomNumber(2)+1;
    }
    else 
    {
    numPh=Greenfoot.getRandomNumber(2)+1;
    numPv=1;
    }
    switch(rcuartos)
    {
    case 1:
    case 2:
    if(numPh==1)
    ParedH pa1=new ParedH();
    else if(numPh==2)
    {
    ParedH pa2=new ParedH();
    ParedH pa3=new ParedH();
    }
    else if(numPh==3)
    {
    ParedH pa4=new ParedH();
    ParedH pa5=new ParedH();
    ParedH pa6=new ParedH();
    }
    else if(numPh==4)
    {
    ParedH pa7=new ParedH();
    ParedH pa8=new ParedH();
    ParedH pa9=new ParedH();
    ParedH pa10=new ParedH();
    }
    if(numPv==1)
    ParedV pa1=new ParedV();
    else if(numPv==2)
    {
    ParedV pa2=new ParedV();
    ParedV pa3=new ParedV();
    }
    else if(numPv==3)
    {
    ParedV pa4=new ParedV();
    ParedV pa5=new ParedV();
    ParedV pa6=new ParedV();
    }
    else if(numPv==4)
    {
    ParedV pa7=new ParedV();
    ParedV pa8=new ParedV();
    ParedV pa9=new ParedV();
    ParedV pa10=new ParedV();
    }
    break;
    case 3:
    case 4:
    if(numPh==1)
    ParedH pa11=new ParedH();
    else if(numPh==2)
    {
    ParedH pa12=new ParedH();
    ParedH pa13=new ParedH();
    }
    if(numPv==1)
    ParedV pa11=new ParedV();
    else if(numPv==2)
    {
    ParedV pa12=new ParedV();
    ParedV pa13=new ParedV();
    }
    break;
    }
    }*/

    /**
     * Metodo que prepara la creacion del nivel final del juego contra el dragon.
     */
    private void nivelFinal()
    {
        setBackground("final.png");
        removeObjects(getObjects(Escalera.class));
        removeObjects(getObjects(Ene1.class));
        removeObjects(getObjects(Ene2.class));
        removeObjects(getObjects(Pocion.class));
        removeObjects(getObjects(Llave.class));
        //jugador.setLocation(454, 369);
        Canon canon = new Canon(1);
        addObject(canon, 408, 153);
        Canon canon2 = new Canon(2);
        addObject(canon2, 415, 244);
        Canon canon3 = new Canon(3);
        addObject(canon3, 406, 340);
        canon3.setLocation(399, 341);
        canon.setLocation(399, 154);
        canon2.setLocation(399, 249);
        Dragon dragon = new Dragon();
        addObject(dragon, 108, 146);
        dragon.setLocation(103, 136);
        //jugador.setLocation(280,410);
    }
    
    /**
     * Metodo que actua cuando es presionado el boton de jugar, cambia el fondo y pide la generacion del primer nivel.
     */
    public void Presiona()
    {
        setLevel(nivel);
        setBackground("background.png");
        
    }
    
    /**
     * Metodo para cambiar la musica a escuchar.
     */
    public void cambia()
    {
        track1.pause();
        track2.playLoop();
    }
    
    /**
     * Metodo para detener una cancion e iniciar otra durante el juego.
     */
    public void reproduce()
    {
        track2.pause();
        track1.playLoop();
    }
    
    /**
     * Detiene la reproduccion del sonido principal
     */
    public void stopped()
    {
        track1.pause(); 
        track2.pause();
    }
    
    /**
     * Inicia la reproduccion del sonido track 1
     */
    public void start1()
    {
        track1.playLoop();
    }
    
    /**
     * Prepara la creacion del primer nivel del juego.
     */
    private void nivel1()
    {
        addObject(muestra, 50, 465);
        Escalera escalera = new Escalera();
        addObject(escalera, 475, 37);
        Jugador jugador = new Jugador();
        addObject(jugador, 297, 396);
        Ene2 ene2 = new Ene2();
        addObject(ene2, 394, 293);
        Ene2 ene22 = new Ene2();
        addObject(ene22, 241, 309);
        Ene2 ene23 = new Ene2();
        addObject(ene23, 127, 292);
        Ene1 ene1 = new Ene1();
        addObject(ene1, 465, 200);
        Ene1 ene12 = new Ene1();
        addObject(ene12, 327, 215);
        Ene1 ene13 = new Ene1();
        addObject(ene13, 214, 203);
        letrero= new Letrero();
        addObject(letrero,445,475);
        letrero.cambiaLetrero(nivel);
        
    }
    
}
