import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Clase del actor jugador, en esta clase se realizan todos los movimientos y efectos del jugador, movimientos, ataques.
 */
public class Jugador extends Actor
{
    private int inix=280;
    private int iniy=410;
    private int pasos=3;
    private int llave=0;
    
    private int NORTE=3;
    private int ESTE=2;
    private int SUR=4;
    private int OESTE=1;
   
    private GreenfootImage quietoN =null;
    private GreenfootImage quietoS =null;
    private GreenfootImage quietoE =null;
    private GreenfootImage quietoO =null;
    private GreenfootImage[] atacklft =null;
    private GreenfootImage[] atackr =null;
    private GreenfootImage[] atackup=null;
    private GreenfootImage[] atackdn=null;
    private GreenfootImage[] mueveE=null;
    private GreenfootImage[] mueveO=null;
    private GreenfootImage[] mueveN=null;
    private GreenfootImage[] mueveS=null;
    private int dir;
   
    /**
     * Constructor del personaje, se inicializan los arreglos de imagenes del jugador.
     */
    public Jugador()
    {
         dir=NORTE;
         quietoE=new GreenfootImage("quietoder.png");
         quietoN=new GreenfootImage("quietoup.png");
         quietoO=new GreenfootImage("quietoizq.png");
         quietoS=new GreenfootImage("quietodown.png");
         
         mueveN=new GreenfootImage[3];
         mueveN[0]=new GreenfootImage("wup1.png");
         mueveN[1]=new GreenfootImage("wup2.png");
         mueveN[2]=new GreenfootImage("wup3.png");
         
         mueveE=new GreenfootImage[3];
         mueveE[0]=new GreenfootImage("wr1.png");
         mueveE[1]=new GreenfootImage("wr2.png");
         mueveE[2]=new GreenfootImage("wr3.png");
         
         mueveS=new GreenfootImage[3];
         mueveS[0]=new GreenfootImage("wdn1.png");
         mueveS[1]=new GreenfootImage("wdn2.png");
         mueveS[2]=new GreenfootImage("wdn3.png");
         
         mueveO=new GreenfootImage[3];
         mueveO[0]=new GreenfootImage("wl1.png");
         mueveO[1]=new GreenfootImage("wl2.png");
         mueveO[2]=new GreenfootImage("wl3.png");
         
         atackup = new GreenfootImage[5];
         atackup[0]=new GreenfootImage("atacku1.png");
         atackup[1]=new GreenfootImage("atacku2.png");
         atackup[2]=new GreenfootImage("atacku3.png");
         atackup[3]=new GreenfootImage("atacku4.png");
         atackup[4]=new GreenfootImage("atacku5.png");
         
         atackdn= new GreenfootImage[6];
         atackdn[0]=new GreenfootImage("atackd1.png");
         atackdn[1]=new GreenfootImage("atackd2.png");
         atackdn[2]=new GreenfootImage("atackd3.png");
         atackdn[3]=new GreenfootImage("atackd4.png");
         atackdn[4]=new GreenfootImage("atackd5.png");
         atackdn[5]=new GreenfootImage("atackd6.png");
         
         atacklft= new GreenfootImage[5];
         atacklft[0]=new GreenfootImage("atackleft1.png");
         atacklft[1]=new GreenfootImage("atackleft2.png");
         atacklft[2]=new GreenfootImage("atackleft3.png");
         atacklft[3]=new GreenfootImage("atackleft4.png");
         atacklft[4]=new GreenfootImage("atackleft5.png");
         
         atackr= new GreenfootImage[5];
         atackr[0]=new GreenfootImage("atackright1.png");
         atackr[1]=new GreenfootImage("atackright2.png");
         atackr[2]=new GreenfootImage("atackright3.png");
         atackr[3]=new GreenfootImage("atackright4.png");
         atackr[4]=new GreenfootImage("atackright5.png");
    }
    
    /**
     * actua del jugador aqui es donde se establecen las acciones a realizar por parte del jugador asi como el orden de estaqs acciones.
     */
    public void act() 
    {
        Escalera esc=null;
        esc=(Escalera)encontroEscalera();
        switch(dir)
        {
              case 1:
                setImage(quietoO);
                break;
              case 2:
                setImage(quietoE);
                break;
              case 3:
                setImage(quietoN);
                break;
            case 4:
                setImage(quietoS);
                break;
        }
        movimiento();
        if(encontroLlave())
        {
            tomaLlave();
        }
        if(encontroPocion())
        {
            tomaPocion();
        }
        if(esc!=null)
        {
            setLocation(inix,iniy);
            cambiaNivel();
        }
        if(encontroEn1()||encontroEn2())
        {
            quitaVida();
            setLocation(inix,iniy);
            if(encontroEn1())
               golpeEnemigo();
        }
    }    
    
    /**
     * En este metodo se realiza la captula de la tecla ya sea para la direccion del movimiento, la animacion del movimiento y la reubicacion del jugador, asi mismo se 
     * llama al metodo encargado del ataque.
     */
    public void movimiento()
    {
        int opcion=0;
        if(Greenfoot.isKeyDown("right"))
            opcion=1;
        else if(Greenfoot.isKeyDown("left"))
            opcion=2;
        else if(Greenfoot.isKeyDown("up"))
            opcion=3;
        else if(Greenfoot.isKeyDown("down"))
            opcion=4;
        else if(Greenfoot.isKeyDown("a"))
            opcion=5;
        
        switch(opcion)
        {
              case 1:
                dir=ESTE;
                for(int i=0;i<3;i++)
                {
                    setImage(mueveE[i]);
                    setLocation(getX()+(pasos/3),getY());
                }
                break;
              case 2:
                dir=OESTE;
                for(int i=0;i<3;i++)
                {
                    setImage(mueveO[i]);
                    setLocation(getX()-(pasos/3),getY());
                }
                break;
              case 3:
                dir=NORTE;
                for(int i=0;i<3;i++)
                {
                    setImage(mueveN[i]);
                    setLocation(getX(),getY()-(pasos/3));
                }
                break;
            case 4:
                dir=SUR;
                for(int i=0;i<3;i++)
                {
                    setImage(mueveS[i]);
                    setLocation(getX(),getY()+(pasos/3));
                }
                break;
            case 5:
                ataque();
                break;
        }
    }
    
    /**
     * En este metodo se hace la animacion del ataque del personaje dependiendo de la direccion que este obserbando.
     */
    public void ataque()
    {
        int numcanon=0;
        Canon canon=null;
        canon=(Canon)encontroCanon();
        boolean bala=false;
        
        switch(dir)
        {
              case 1:
                for(int i=0;i<5;i++){
                    setImage(atacklft[i]);
                    Greenfoot.delay(1);
                }
                break;
              case 2:
                for(int i=0;i<5;i++){
                    setImage(atackr[i]);
                    Greenfoot.delay(1);
                }
                break;
              case 3:
                for(int i=0;i<5;i++){
                    setImage(atackup[i]);
                    Greenfoot.delay(1);
                }
                break;
            case 4:
                for(int i=0;i<5;i++){
                    setImage(atackdn[i]);
                    Greenfoot.delay(1);
                }
                break;
        }
        if(canon!=null)
        {
            numcanon=canon.dameNumero();
            bala=canon.cargado();
            if(bala==true)
               ((Calabozo) getWorld()).dispara(numcanon);
               canon.bala();
        }
        eliminaEnemigo1();
        eliminaEnemigo2();
    }
    
    /**
     * En este metodo se verifica si se encuentra el jugador una escalera para poder pasar al siguiente nivel.
     */
    public Actor encontroEscalera()
    {
        Actor escalera=null;
        escalera=getOneIntersectingObject(Escalera.class);
        return escalera;  
    }
    
    /**
     * Verifica si se encontro un Canon y regresa el canon encontrado.
     */
    public Actor encontroCanon()
    {
        Actor canon=null;
        canon=getOneIntersectingObject(Canon.class);
        return canon;  
    }
    
    /**
     * Metodo para pasar de nivel al encontrar la escalera.
     */
    public void cambiaNivel()
    {
        ((Calabozo) getWorld()).nextLevel(); 
    }
    
    /**
     * Metodo para pedir la reducion de una vida del jugador.
     */
    public void quitaVida()
    {
        ((Calabozo) getWorld()).reduceVida(); 
    }
    
    /**
     * Metodo que verifica si el jugador se encuentra una llave.
     */
    public boolean encontroLlave()
    {
        Actor key= getOneObjectAtOffset(0, 0, Llave.class);
        if(key!= null)
            return true;
        else
            return false;
    }
    
    /**
     * Metodo que verifica si el jugador se encuentra una pocion.
     */
    public boolean encontroPocion()
    {
        Actor pocion= getOneObjectAtOffset(0, 0, Pocion.class);
        if(pocion!= null)
            return true;
        else
            return false;
    }
    
    /**
     * metodo que pide el aumento de la vida en uno al haber encontrado una pocion.
     */
    public void tomaPocion()
    {
        Actor pocion = getOneObjectAtOffset(0, 0, Pocion.class);
        if(pocion!= null) {
            getWorld().removeObject(pocion);
            ((Calabozo) getWorld()).aumentaVida();
        }
    }
    
    /**
     * Metodo para toma una llave y aumentar el contador de esta.
     */
    public void tomaLlave()
    {
        Actor key = getOneObjectAtOffset(0, 0, Llave.class);
        if(key!= null) {
            getWorld().removeObject(key);
            llave=llave+1; 
        }
    }
    
    /**
     * Metodo para verificar si el jugador se encontro con un enemigo dependiendo de la direccion.
     */
    public boolean encontroEn1()
    {
         Actor ene=null;
         boolean res=false;
        switch(dir)
        {
              case 1:
                ene= getOneObjectAtOffset(10, 0, Ene1.class);
                if(ene!= null)
                   res= true;
                break;
              case 2:
                ene= getOneObjectAtOffset(-10, 0, Ene1.class);
                if(ene!= null)
                   res= true;
                break;
              case 3:
                ene= getOneObjectAtOffset(0, -10, Ene1.class);
                if(ene!= null)
                   res= true;
                break;
            case 4:
                ene= getOneObjectAtOffset(0, 10, Ene1.class);
                if(ene!= null)
                   res= true;
                break;
        }
        return res;
    }
    
    /**
     * metodo para saber si el enemigo golpea al jugador.
     */
    public void golpeEnemigo()
    {
        Actor ene=null;
        switch(dir)
        {
              case 1:
                ene= getOneObjectAtOffset(10, 0, Ene1.class);
                break;
              case 2:
                ene= getOneObjectAtOffset(-10, 0, Ene1.class);
                break;
              case 3:
                ene= getOneObjectAtOffset(0, -10, Ene1.class);
                break;
            case 4:
                ene= getOneObjectAtOffset(0, 10, Ene1.class);
                break;
        }
         getWorld().removeObject(ene);
    }
    
    /**
     * Metodo para saber si se encontro a un enemigo dependiendo de la direccion.
     */
    public boolean encontroEn2()
    {
        Actor ene=null;
         boolean res=false;
        switch(dir)
        {
              case 1:
                ene= getOneObjectAtOffset(10, 0, Ene2.class);
                if(ene!= null)
                   res= true;
                break;
              case 2:
                ene= getOneObjectAtOffset(-10, 0, Ene2.class);
                if(ene!= null)
                   res= true;
                break;
              case 3:
                ene= getOneObjectAtOffset(0, -10, Ene2.class);
                if(ene!= null)
                   res= true;
                break;
            case 4:
                ene= getOneObjectAtOffset(0, 10, Ene2.class);
                if(ene!= null)
                   res= true;
                break;
        }
        return res;
    }
    
    /**
     * Metodo para desaparecer el actor enemigo que haya eliminado el jugador.
     */
    public void eliminaEnemigo1()
    {
        Actor ene=null;
        switch(dir)
        {
              case 1:
                ene= getOneObjectAtOffset(-10, 0, Ene1.class);
                if(ene!= null)
                   getWorld().removeObject(ene);
                break;
              case 2:
                ene= getOneObjectAtOffset(10, 0, Ene1.class);
                if(ene!= null)
                   getWorld().removeObject(ene);
                break;
              case 3:
                ene= getOneObjectAtOffset(0, -15, Ene1.class);
                if(ene!= null)
                   getWorld().removeObject(ene);
                break;
            case 4:
                ene= getOneObjectAtOffset(0, 15, Ene1.class);
                if(ene!= null)
                   getWorld().removeObject(ene);
                break;
        }
      
    }
    
    /**
     * Metodo para desaparecer el actor enemigo que haya eliminado el jugador.
     */
    public void eliminaEnemigo2()
    {
         Actor ene=null;
        switch(dir)
        {
              case 1:
                ene= getOneObjectAtOffset(-10, 0, Ene2.class);
                if(ene!= null)
                   getWorld().removeObject(ene);
                break;
              case 2:
                ene= getOneObjectAtOffset(10, 0, Ene2.class);
                if(ene!= null)
                   getWorld().removeObject(ene);
                break;
              case 3:
                ene= getOneObjectAtOffset(0, -15, Ene2.class);
                if(ene!= null)
                   getWorld().removeObject(ene);
                break;
            case 4:
                ene= getOneObjectAtOffset(0, 15, Ene2.class);
                if(ene!= null)
                   getWorld().removeObject(ene);
                break;
        }
    }
}
